"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var plenty_alert_1 = require('../../alert/plenty-alert');
var PlentyInputComponent = (function () {
    function PlentyInputComponent(inputType, inputRegex) {
        this.inputType = inputType;
        this.inputRegex = inputRegex;
        this.alert = plenty_alert_1.PlentyAlert.getInstance();
        this.innerValue = '';
        this.onTouchedCallback = function () {
        };
        this.onChangeCallback = function () {
        };
        this.type = inputType;
        this.regex = inputRegex;
        this.isValid = true;
        this.tooltipPlacement = 'top';
    }
    Object.defineProperty(PlentyInputComponent.prototype, "isDisabled", {
        get: function () {
            return this.disabled;
        },
        set: function (value) {
            this.disabled = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PlentyInputComponent.prototype, "isValid", {
        get: function () {
            return this._isValid;
        },
        set: function (value) {
            this._isValid = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PlentyInputComponent.prototype, "value", {
        get: function () {
            return this.innerValue;
        },
        set: function (v) {
            if (v !== this.innerValue) {
                this.innerValue = v;
                this.onChangeCallback(v);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    PlentyInputComponent.prototype.onBlur = function () {
        this.onTouchedCallback();
    };
    PlentyInputComponent.prototype.writeValue = function (value) {
        if (value !== this.innerValue) {
            this.innerValue = value;
        }
    };
    PlentyInputComponent.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    PlentyInputComponent.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    PlentyInputComponent.prototype.validate = function (formControl) {
        if (formControl.valid) {
            this.isValid = true;
        }
        else {
            if (!this.isDisabled) {
                this.isValid = false;
                if (this.isRequired && this.value.length == 0) {
                    var emptyMessage = void 0;
                    if (!this.emptyMessage || this.emptyMessage.length == 0) {
                        emptyMessage = 'Mach eine Eingabe!';
                    }
                    else {
                        emptyMessage = this.emptyMessage;
                    }
                    this.alert.addAlert(emptyMessage, true, 'danger', 0);
                }
                else if (this.value.length > 0) {
                    var invalidMessage = void 0;
                    if (!this.invalidMessage || this.invalidMessage.length == 0) {
                        invalidMessage = 'Eingabe ungültig!';
                    }
                    else {
                        invalidMessage = this.invalidMessage;
                    }
                    this.alert.addAlert(invalidMessage, true, 'danger', 0);
                }
            }
        }
    };
    Object.defineProperty(PlentyInputComponent.prototype, "regex", {
        get: function () {
            return this._regex;
        },
        set: function (value) {
            this._regex = value;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], PlentyInputComponent.prototype, "name", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], PlentyInputComponent.prototype, "isRequired", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], PlentyInputComponent.prototype, "emptyMessage", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], PlentyInputComponent.prototype, "invalidMessage", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], PlentyInputComponent.prototype, "tooltipText", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], PlentyInputComponent.prototype, "disabled", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], PlentyInputComponent.prototype, "tooltipPlacement", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], PlentyInputComponent.prototype, "maxLength", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], PlentyInputComponent.prototype, "maxValue", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], PlentyInputComponent.prototype, "minLength", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], PlentyInputComponent.prototype, "minValue", void 0);
    return PlentyInputComponent;
}());
exports.PlentyInputComponent = PlentyInputComponent;
//# sourceMappingURL=/app/forms/input/plenty-input.component.js.map