"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var Observable_1 = require('rxjs/Observable');
(function (PlentyLoadingBarEventType) {
    PlentyLoadingBarEventType[PlentyLoadingBarEventType["PROGRESS"] = 0] = "PROGRESS";
    PlentyLoadingBarEventType[PlentyLoadingBarEventType["HEIGHT"] = 1] = "HEIGHT";
    PlentyLoadingBarEventType[PlentyLoadingBarEventType["COLOR"] = 2] = "COLOR";
    PlentyLoadingBarEventType[PlentyLoadingBarEventType["VISIBLE"] = 3] = "VISIBLE";
})(exports.PlentyLoadingBarEventType || (exports.PlentyLoadingBarEventType = {}));
var PlentyLoadingBarEventType = exports.PlentyLoadingBarEventType;
var PlentyLoadingBarEvent = (function () {
    function PlentyLoadingBarEvent(type, value) {
        this.type = type;
        this.value = value;
    }
    return PlentyLoadingBarEvent;
}());
exports.PlentyLoadingBarEvent = PlentyLoadingBarEvent;
var PlentyLoadingBarService = (function () {
    function PlentyLoadingBarService() {
        var _this = this;
        this._progress = 0;
        this._height = '2px';
        this._color = 'firebrick';
        this._visible = true;
        this._intervalCounterId = 0;
        this.interval = 500;
        this.observable = new Observable_1.Observable(function (subscriber) {
            _this.subscriber = subscriber;
        });
    }
    Object.defineProperty(PlentyLoadingBarService.prototype, "progress", {
        get: function () {
            return this._progress;
        },
        set: function (value) {
            if (value != null) {
                if (value > 0) {
                    this.visible = true;
                }
                this._progress = value;
                this.emitEvent(new PlentyLoadingBarEvent(PlentyLoadingBarEventType.PROGRESS, this._progress));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PlentyLoadingBarService.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            if (value != null) {
                this._height = value;
                this.emitEvent(new PlentyLoadingBarEvent(PlentyLoadingBarEventType.HEIGHT, this._height));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PlentyLoadingBarService.prototype, "color", {
        get: function () {
            return this._color;
        },
        set: function (value) {
            if (value != null) {
                this._color = value;
                this.emitEvent(new PlentyLoadingBarEvent(PlentyLoadingBarEventType.COLOR, this._color));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PlentyLoadingBarService.prototype, "visible", {
        get: function () {
            return this._visible;
        },
        set: function (value) {
            if (value != null) {
                this._visible = value;
                this.emitEvent(new PlentyLoadingBarEvent(PlentyLoadingBarEventType.VISIBLE, this._visible));
            }
        },
        enumerable: true,
        configurable: true
    });
    PlentyLoadingBarService.prototype.emitEvent = function (event) {
        if (this.subscriber) {
            this.subscriber.next(event);
        }
    };
    PlentyLoadingBarService.prototype.start = function () {
        var _this = this;
        this.stop();
        this.visible = true;
        this._intervalCounterId = setInterval(function () {
            _this.progress++;
            if (_this.progress === 100) {
                _this.complete();
            }
        }, this.interval);
    };
    PlentyLoadingBarService.prototype.stop = function () {
        if (this._intervalCounterId) {
            clearInterval(this._intervalCounterId);
            this._intervalCounterId = null;
        }
    };
    PlentyLoadingBarService.prototype.reset = function () {
        this.stop();
        this.progress = 0;
    };
    PlentyLoadingBarService.prototype.complete = function () {
        var _this = this;
        this.progress = 100;
        this.stop();
        setTimeout(function () {
            _this.visible = false;
            setTimeout(function () {
                _this.progress = 0;
            }, 250);
        }, 250);
    };
    PlentyLoadingBarService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [])
    ], PlentyLoadingBarService);
    return PlentyLoadingBarService;
}());
exports.PlentyLoadingBarService = PlentyLoadingBarService;
//# sourceMappingURL=/app/loading-bar/service/plenty-loading-bar.service.js.map