"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var ng2_bootstrap_1 = require('ng2-bootstrap/ng2-bootstrap');
var plenty_button_component_1 = require('../button/plenty-button.component');
var PlentyOverlayComponent = (function () {
    function PlentyOverlayComponent() {
        this.hasPrimaryButton = false;
        this.hasSecondaryButton = false;
        this.isStatic = false;
        this.isCloseable = true;
        this.isLarge = false;
        this.isSmall = false;
        this.primaryButtonClicked = new core_1.EventEmitter();
        this.secondaryButtonClicked = new core_1.EventEmitter();
    }
    PlentyOverlayComponent.prototype.ngAfterViewInit = function () {
        if (!this.isCloseable) {
            this.isStatic = true;
        }
        if (this.isStatic) {
            this.overlay.config.backdrop = 'static';
            this.overlay.config.keyboard = false;
        }
    };
    PlentyOverlayComponent.prototype.primaryClicked = function () {
        this.primaryButtonClicked.emit(this);
    };
    PlentyOverlayComponent.prototype.secondaryClicked = function () {
        this.secondaryButtonClicked.emit(this);
    };
    PlentyOverlayComponent.prototype.showOverlay = function () {
        this.overlay.show();
    };
    PlentyOverlayComponent.prototype.hideOverlay = function () {
        this.overlay.hide();
    };
    __decorate([
        core_1.ViewChild('overlay'), 
        __metadata('design:type', ng2_bootstrap_1.ModalDirective)
    ], PlentyOverlayComponent.prototype, "overlay", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], PlentyOverlayComponent.prototype, "addButtonTooltip", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], PlentyOverlayComponent.prototype, "cancelButtonTooltip", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], PlentyOverlayComponent.prototype, "overlayTitle", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], PlentyOverlayComponent.prototype, "hasPrimaryButton", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], PlentyOverlayComponent.prototype, "hasSecondaryButton", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], PlentyOverlayComponent.prototype, "isStatic", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], PlentyOverlayComponent.prototype, "isCloseable", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], PlentyOverlayComponent.prototype, "isLarge", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], PlentyOverlayComponent.prototype, "isSmall", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], PlentyOverlayComponent.prototype, "primaryButtonClicked", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], PlentyOverlayComponent.prototype, "secondaryButtonClicked", void 0);
    PlentyOverlayComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: 'overlay',
            templateUrl: 'plenty-overlay.component.html',
            viewProviders: [ng2_bootstrap_1.BS_VIEW_PROVIDERS],
            directives: [
                ng2_bootstrap_1.MODAL_DIRECTIVES,
                plenty_button_component_1.PlentyButtonComponent
            ],
        }), 
        __metadata('design:paramtypes', [])
    ], PlentyOverlayComponent);
    return PlentyOverlayComponent;
}());
exports.PlentyOverlayComponent = PlentyOverlayComponent;
//# sourceMappingURL=/app/overlay/plenty-overlay.component.js.map