"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var plenty_base_toolbar_component_1 = require('../toolbar/base-toolbar/plenty-base-toolbar.component');
var plenty_button_component_1 = require('../button/plenty-button.component');
var plenty_list_box_component_1 = require('../forms/list-box/plenty-list-box.component');
var plenty_number_input_component_1 = require('../forms/input/number-input/plenty-number-input.component');
var PlentyPagerComponent = (function () {
    function PlentyPagerComponent() {
        this.doPaging = new core_1.EventEmitter();
    }
    PlentyPagerComponent.prototype.ngOnInit = function () {
        if (!this.defaultPagingSize) {
            this.defaultPagingSize = 25;
        }
        if (!this.pagingSize) {
            this.pagingSize = [
                {
                    value: 25,
                    caption: '25'
                },
                {
                    value: 50,
                    caption: '50'
                },
                {
                    value: 75,
                    caption: '75'
                },
                {
                    value: 100,
                    caption: '100'
                }
            ];
        }
        this.pagingData = {
            pagingUnit: 'Entries',
            total: 0,
            currentPage: 1,
            perPage: 0,
            lastPage: 0,
            from: 0,
            to: 0
        };
        this.updateCurrentPageInput();
    };
    PlentyPagerComponent.prototype.updateCurrentPageInput = function () {
        this.currentPageInput.value = this.pagingData.currentPage;
    };
    PlentyPagerComponent.prototype.onFirstPage = function () {
        this.pagingData.currentPage = 1;
        this.updateCurrentPageInput();
        this.doPaging
            .emit(this.pagingData);
    };
    PlentyPagerComponent.prototype.onPrevPage = function () {
        this.pagingData.currentPage -= 1;
        this.updateCurrentPageInput();
        this.doPaging
            .emit(this.pagingData);
    };
    PlentyPagerComponent.prototype.onNextPage = function () {
        this.pagingData.currentPage += 1;
        this.updateCurrentPageInput();
        this.doPaging
            .emit(this.pagingData);
    };
    PlentyPagerComponent.prototype.onLastPage = function () {
        this.pagingData.currentPage = this.pagingData.lastPage;
        this.updateCurrentPageInput();
        this.doPaging
            .emit(this.pagingData);
    };
    PlentyPagerComponent.prototype.onReload = function () {
        this.doPaging
            .emit(this.pagingData);
    };
    PlentyPagerComponent.prototype.onToPage = function (event, pageNumber) {
        event.preventDefault();
        this.pagingData.currentPage = pageNumber;
        this.doPaging
            .emit(this.pagingData);
    };
    PlentyPagerComponent.prototype.onChangeOffsetTo = function (selectedOffset) {
        this.pagingData.currentPage = 1;
        this.updateCurrentPageInput();
        this.pagingData.perPage = selectedOffset.value;
        this.doPaging
            .emit(this.pagingData);
    };
    __decorate([
        core_1.ViewChild(plenty_number_input_component_1.PlentyNumberInputComponent), 
        __metadata('design:type', plenty_number_input_component_1.PlentyNumberInputComponent)
    ], PlentyPagerComponent.prototype, "currentPageInput", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], PlentyPagerComponent.prototype, "pagingData", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], PlentyPagerComponent.prototype, "defaultPagingSize", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], PlentyPagerComponent.prototype, "pagingSize", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], PlentyPagerComponent.prototype, "doPaging", void 0);
    PlentyPagerComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: 'plenty-pager',
            templateUrl: 'plenty-pager.component.html',
            styleUrls: ['plenty-pager.component.css'],
            directives: [plenty_base_toolbar_component_1.PlentyBaseToolbarComponent,
                plenty_button_component_1.PlentyButtonComponent,
                plenty_list_box_component_1.PlentyListBoxComponent,
                plenty_number_input_component_1.PlentyNumberInputComponent]
        }), 
        __metadata('design:paramtypes', [])
    ], PlentyPagerComponent);
    return PlentyPagerComponent;
}());
exports.PlentyPagerComponent = PlentyPagerComponent;
//# sourceMappingURL=/app/pager/plenty-pager.component.js.map