"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
require('rxjs/add/operator/map');
require('rxjs/Rx');
var plenty_loading_bar_service_1 = require('../loading-bar/service/plenty-loading-bar.service');
var BaseService = (function () {
    function BaseService(loadingBarService, _http, url) {
        this.loadingBarService = loadingBarService;
        this._http = _http;
        this.headers = new http_1.Headers({ 'Content-Type': 'application/json' });
        this.setAuthorization();
        this.url = url;
    }
    Object.defineProperty(BaseService.prototype, "http", {
        get: function () {
            return this._http;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseService.prototype, "headers", {
        get: function () {
            return this._headers;
        },
        set: function (value) {
            this._headers = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseService.prototype, "url", {
        get: function () {
            return this._url;
        },
        set: function (value) {
            this._url = value;
        },
        enumerable: true,
        configurable: true
    });
    BaseService.prototype.setToHeader = function (key, value) {
        this.headers.set(key, value);
    };
    BaseService.prototype.deleteFromHeader = function (key) {
        this.headers.delete(key);
    };
    BaseService.prototype.setAuthorization = function () {
        if (localStorage.getItem('accessToken')) {
            this.setToHeader('Authorization', 'Bearer ' + localStorage.getItem('accessToken'));
        }
    };
    BaseService.prototype.mapRequest = function (request) {
        var _this = this;
        this.loadingBarService.start();
        var req = request.map(function (response) { return response.json(); }).share();
        req.subscribe(function () {
            _this.loadingBarService.complete();
        }, function (error) {
            _this.loadingBarService.complete();
        });
        return req;
    };
    BaseService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [plenty_loading_bar_service_1.PlentyLoadingBarService, http_1.Http, String])
    ], BaseService);
    return BaseService;
}());
exports.BaseService = BaseService;
//# sourceMappingURL=/app/service/base.service.js.map