import { EventEmitter } from '@angular/core';
import { Observable } from 'rxjs/Observable';
import { PlentyTableHeaderCell } from '../cell/plenty-table-header-cell';
import { PlentyTableRow } from '../row/plenty-table-row';
import { BaseService } from '../../service/base.service';
import { PlentyPagerData } from '../../pager/data/plenty-pager-data';
import { PlentyListBoxValue } from '../../forms/list-box/value/plenty-list-box-value';
import { PlentyCheckboxComponent } from '../../forms/checkbox/plenty-checkbox.component';
import { BaseData } from '../../data/base-data';
export declare class PlentyDataTableComponent<S extends BaseService, D extends BaseData> {
    service: S;
    doPagingEvent: EventEmitter<PlentyPagerData>;
    headerCheckbox: PlentyCheckboxComponent;
    private _headerList;
    private _rowList;
    private _selectedRowList;
    private isHeaderCheckboxChecked;
    private _pagingData;
    private _pagingSize;
    private _defaultPagingSize;
    private _onSuccessFunction;
    constructor();
    private onHeaderCheckboxChange(isChecked);
    private onRowCheckboxChange(isChecked, row);
    private changeRowState(isChecked, rowToChange);
    headerList: Array<PlentyTableHeaderCell>;
    rowList: Array<PlentyTableRow<D>>;
    deleteRow(rowToDelete: PlentyTableRow<D>): void;
    selectedRowList: Array<PlentyTableRow<D>>;
    pagingData: PlentyPagerData;
    doPaging(pagerData: PlentyPagerData): void;
    pagingSize: Array<PlentyListBoxValue>;
    defaultPagingSize: number;
    onSuccessFunction: (res) => void;
    doSearch(restCall: Observable<D>): void;
}
