"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var plenty_button_component_1 = require('../../button/plenty-button.component');
var ng2_bootstrap_1 = require('ng2-bootstrap/ng2-bootstrap');
var plenty_data_table_context_menu_directive_1 = require('./context-menu/directive/plenty-data-table-context-menu.directive');
var plenty_data_table_context_menu_component_1 = require('./context-menu/plenty-data-table-context-menu.component');
var plenty_pager_component_1 = require('../../pager/plenty-pager.component');
var plenty_checkbox_component_1 = require('../../forms/checkbox/plenty-checkbox.component');
var PlentyDataTableComponent = (function () {
    function PlentyDataTableComponent() {
        this.doPagingEvent = new core_1.EventEmitter();
        this._selectedRowList = [];
        this.isHeaderCheckboxChecked = false;
    }
    PlentyDataTableComponent.prototype.onHeaderCheckboxChange = function (isChecked) {
        var _this = this;
        this.isHeaderCheckboxChecked = isChecked;
        this.rowList.forEach(function (row) {
            _this.changeRowState(isChecked, row);
        });
    };
    PlentyDataTableComponent.prototype.onRowCheckboxChange = function (isChecked, row) {
        this.changeRowState(isChecked, row);
        if (this.selectedRowList.length == 0) {
            this.isHeaderCheckboxChecked = false;
        }
        else if (this.selectedRowList.length > 0 && this.rowList.length == this.selectedRowList.length) {
            this.isHeaderCheckboxChecked = true;
        }
        else {
            this.headerCheckbox.isIndeterminate = true;
        }
    };
    PlentyDataTableComponent.prototype.changeRowState = function (isChecked, rowToChange) {
        rowToChange.selected = isChecked;
        var rowFound = false;
        this.selectedRowList.forEach(function (row) {
            if (row == rowToChange) {
                rowFound = true;
            }
        });
        if (rowToChange.selected) {
            if (!rowFound) {
                this.selectedRowList.push(rowToChange);
            }
        }
        else {
            var index = this.selectedRowList.indexOf(rowToChange);
            this.selectedRowList.splice(index, 1);
        }
    };
    Object.defineProperty(PlentyDataTableComponent.prototype, "headerList", {
        get: function () {
            return this._headerList;
        },
        set: function (value) {
            this._headerList = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PlentyDataTableComponent.prototype, "rowList", {
        get: function () {
            return this._rowList;
        },
        set: function (value) {
            this._rowList = value;
            this.rowList.forEach(function (row) { return row.contextMenuLinkList.forEach(function (l) { return l.subject.subscribe(function (val) { return val.clickFunction(val); }); }); });
        },
        enumerable: true,
        configurable: true
    });
    PlentyDataTableComponent.prototype.deleteRow = function (rowToDelete) {
        var index = this.rowList.indexOf(rowToDelete);
        this.rowList.splice(index, 1);
        var selectedIndex = this.selectedRowList.indexOf(rowToDelete);
        if (selectedIndex != null) {
            this.selectedRowList.splice(selectedIndex, 1);
        }
    };
    Object.defineProperty(PlentyDataTableComponent.prototype, "selectedRowList", {
        get: function () {
            return this._selectedRowList;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PlentyDataTableComponent.prototype, "pagingData", {
        get: function () {
            return this._pagingData;
        },
        set: function (value) {
            this._pagingData = value;
        },
        enumerable: true,
        configurable: true
    });
    PlentyDataTableComponent.prototype.doPaging = function (pagerData) {
        var _this = this;
        this.doPagingEvent.emit(pagerData);
        this.isHeaderCheckboxChecked = false;
        this.rowList.forEach(function (row) {
            _this.changeRowState(false, row);
        });
    };
    Object.defineProperty(PlentyDataTableComponent.prototype, "pagingSize", {
        get: function () {
            return this._pagingSize;
        },
        set: function (value) {
            this._pagingSize = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PlentyDataTableComponent.prototype, "defaultPagingSize", {
        get: function () {
            return this._defaultPagingSize;
        },
        set: function (value) {
            this._defaultPagingSize = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PlentyDataTableComponent.prototype, "onSuccessFunction", {
        get: function () {
            return this._onSuccessFunction;
        },
        set: function (value) {
            this._onSuccessFunction = value;
        },
        enumerable: true,
        configurable: true
    });
    PlentyDataTableComponent.prototype.doSearch = function (restCall) {
        var _this = this;
        restCall.subscribe(function (res) {
            _this.onSuccessFunction(res);
        }, function (error) {
            if (error.status == 401 ||
                error.status == 500) {
                alert(error.status);
            }
        });
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], PlentyDataTableComponent.prototype, "service", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], PlentyDataTableComponent.prototype, "doPagingEvent", void 0);
    __decorate([
        core_1.ViewChild('headerCheckbox'), 
        __metadata('design:type', plenty_checkbox_component_1.PlentyCheckboxComponent)
    ], PlentyDataTableComponent.prototype, "headerCheckbox", void 0);
    PlentyDataTableComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: 'plenty-data-table',
            templateUrl: 'plenty-data-table.component.html',
            directives: [plenty_button_component_1.PlentyButtonComponent,
                ng2_bootstrap_1.TOOLTIP_DIRECTIVES,
                plenty_pager_component_1.PlentyPagerComponent,
                plenty_data_table_context_menu_directive_1.PlentyDataTableContextMenuDirective,
                plenty_data_table_context_menu_component_1.PlentyDataTableContextMenuComponent,
                plenty_checkbox_component_1.PlentyCheckboxComponent]
        }), 
        __metadata('design:paramtypes', [])
    ], PlentyDataTableComponent);
    return PlentyDataTableComponent;
}());
exports.PlentyDataTableComponent = PlentyDataTableComponent;
//# sourceMappingURL=/app/table/data-table/plenty-data-table.component.js.map